
#ifndef GEISS_TEXT_DRAWING_MANAGER
#define GEISS_TEXT_DRAWING_MANAGER 1

#include <d3d8.h>
#include <d3dx8.h>
#include "md_defines.h"

#define MAX_MSGS 4096

typedef struct
{
    char* msg;  // points to some character in g_szMsgPool[2][].
    LPD3DXFONT pfont;  // note: iff this string is really a dark box, pfont will be NULL!
    RECT rect;
    DWORD flags;
    DWORD color;
    int added, deleted;             // temporary; used during DrawNow()
    void* prev_dark_box_ptr;   // temporary; used during DrawNow()
}
td_string;

class CTextManager
{
public:
    CTextManager();
    ~CTextManager();

    // note: if you can't create lpTextSurface full-size, don't create it at all!
    void Init(LPDIRECT3DDEVICE8 lpDevice, IDirect3DTexture8* lpTextSurface, int bAdditive); // note: ok if lpTextSurface==NULL; in that case, text will be drawn directly to screen (but not til end anyway).
    void Finish();

    // note: pFont must persist until DrawNow() is called!
    int  DrawText(LPD3DXFONT pFont, char* szText, RECT* pRect, DWORD flags, DWORD color); // actually queues the text!
    int  DrawText(LPD3DXFONT pFont, char* szText, int len, RECT* pRect, DWORD flags, DWORD color) { 
        return DrawText(pFont, szText, pRect, flags, color); 
    };
    void DrawDarkBox(LPRECT pRect);
    void DrawNow(); 
    void ClearAll(); // automatically called @ end of DrawNow()

protected:
    LPDIRECT3DDEVICE8    m_lpDevice;
    IDirect3DTexture8*   m_lpTextSurface;
    int                  m_blit_additively;

    int       m_nMsg[2];
    td_string m_msg[2][MAX_MSGS];
    char*     m_next_msg_start_ptr;
    int       m_b;
};


#endif